"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseJSONResultsPlugin = void 0;
const object_utils_js_1 = require("../../util/object-utils.js");
class ParseJSONResultsPlugin {
    // noop
    transformQuery(args) {
        return args.node;
    }
    async transformResult(args) {
        const { result } = args;
        return {
            ...args.result,
            rows: result.rows.map(parseRow),
        };
    }
}
exports.ParseJSONResultsPlugin = ParseJSONResultsPlugin;
function parseRow(row) {
    return Object.entries(row).reduce((row, [key, value]) => {
        if ((0, object_utils_js_1.isString)(value) && value.match(/^[\[\{]/) != null) {
            try {
                value = JSON.parse(value);
            }
            catch (err) {
                // this catch block is intentionally empty.
            }
        }
        row[key] = value;
        return row;
    }, {});
}
