/// <reference types="./parse-json-results-plugin.d.ts" />
import { isString } from '../../util/object-utils.js';
export class ParseJSONResultsPlugin {
    // noop
    transformQuery(args) {
        return args.node;
    }
    async transformResult(args) {
        const { result } = args;
        return {
            ...args.result,
            rows: result.rows.map(parseRow),
        };
    }
}
function parseRow(row) {
    return Object.entries(row).reduce((row, [key, value]) => {
        if (isString(value) && value.match(/^[\[\{]/) != null) {
            try {
                value = JSON.parse(value);
            }
            catch (err) {
                // this catch block is intentionally empty.
            }
        }
        row[key] = value;
        return row;
    }, {});
}
